<?php
/**
 * RecommendationApi
 * PHP version 5
 *
 * @category Class
 * @package  Boxx\Loki
 * @author   Boxx Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */

/**
 * Recommendation API 2
 *
 * No description provided (generated by Boxx Codegen https://github.com/Boxx-api/Boxx-codegen)
 *
 * OpenAPI spec version: 1.5.0
 *
 * Generated by: https://github.com/Boxx-api/Boxx-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the Boxx code generator program.
 * https://github.com/Boxx-api/Boxx-codegen
 * Do not edit the class manually.
 */

namespace Boxx\Ai\Recco\Api;

use \Boxx\Ai\Recco\ApiClient;
use \Boxx\Ai\Recco\ApiException;
use \Boxx\Ai\Recco\Configuration;
use \Boxx\Ai\Recco\ObjectSerializer;

/**
 * RecommendationApi Class Doc Comment
 *
 * @category Class
 * @package  Boxx\Loki
 * @author   Boxx Codegen team
 * @link     https://github.com/Boxx-api/Boxx-codegen
 */
class RecommendationApi
{
    /**
     * API Loki
     *
     * @var \Boxx\Loki\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Boxx\Loki\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Boxx\Ai\Recco\ApiClient $apiClient = null)
    {
        if ($apiClient=== null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Boxx\Loki\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Boxx\Loki\ApiClient $apiClient set the API client
     *
     * @return RecommendationApi
     */
    public function setApiClient(\Boxx\Ai\Recco\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation rootPost
     *
     * @param \Boxx\Loki\Model\RecommendationRequestData $request_data request data (required)
     * @throws \Boxx\Loki\ApiException on non-2xx response
     * @return \Boxx\Loki\Model\InlineResponse200
     */
    public function rootPost($request_data)
    {
        list($response) = $this->rootPostWithHttpInfo($request_data);
        return $response;
    }

    /**
     * Operation rootPostWithHttpInfo
     *
     * @param \Boxx\Loki\Model\RecommendationRequestData $request_data request data (required)
     * @throws \Boxx\Loki\ApiException on non-2xx response
     * @return array of \Boxx\Loki\Model\InlineResponse200, HTTP status code, HTTP response headers (array of strings)
     */
    public function rootPostWithHttpInfo($request_data)
    {
        // verify the required parameter 'request_data' is set
        if ($request_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $request_data when calling rootPost');
        }
        // parse inputs
        $resourcePath = "/";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // body params
        $_tempBody = null;
        if (isset($request_data)) {
            $_tempBody = $request_data;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Boxx\Ai\Recco\Model\InlineResponse200',
                '/'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Boxx\Ai\Recco\Model\InlineResponse200', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Recco\Model\InlineResponse200', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Recco\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 401:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Recco\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Boxx\Ai\Recco\Model\InlineResponse400', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
